#include <Windows.h>
#include <tchar.h>

int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR szCmdLine, int iCmdShow);

#ifdef UNICODE
extern "C" int WINAPI wWinMainCRTStartup(void)
#else
extern "C" int WINAPI WinMainCRTStartup(void)
#endif
{
	STARTUPINFO si;
	int mainret;
	CHAR *lpszCommandLine = GetCommandLineA();

	ZeroMemory(&si, sizeof (STARTUPINFO));

	si.cb = sizeof (STARTUPINFO);

	if (*lpszCommandLine == '"') 
	{
		while (*lpszCommandLine && (*lpszCommandLine != '"'))
			lpszCommandLine++;

		if (*lpszCommandLine == '"')
			lpszCommandLine++;
	}
	else    
	{
		while (*lpszCommandLine > ' ')
			lpszCommandLine++;
	}

	while (*lpszCommandLine && (*lpszCommandLine <= ' '))
		lpszCommandLine++;

	GetStartupInfo(&si);

	mainret = _tWinMain(GetModuleHandle(NULL), NULL, lpszCommandLine, 
		si.dwFlags & STARTF_USESHOWWINDOW ? si.wShowWindow : SW_SHOWDEFAULT );

	ExitProcess(mainret);

	return mainret;
}
